Collider = require "collider"
shapes = require "collider.shapes"

require "player"

function love.load()
    function collide(dt, a, b, mtv_x, mtv_y)
        local player, block
            
        if a.info and a.info.type == "player" then
            player = a.info.object
        elseif b.info and b.info.type == "player" then
            player = b.info.object
        end

        if not a.info or not b.info then
            block = true
        end

        --mtv_y = mtv_y or 0

        if player and block then
            player:push(-mtv_x, -mtv_y)
        end
    end

    collider = Collider(32)
    collider:setCallbacks(collide)

    floor = collider:addRectangle(0, 512-32, 1024, 32)

    keys1 = {
        left = "left",
        right = "right",
        jump = "up",
    }

    player1 = Player({0, 0, 255, 255}, keys1,  32, 448)
    collider:addShape(player1.shape)

    piece = shapes.newPolygonShape(
        -16, -48,
         16, -48,
         16, -16,
         48, -16,
         48,  16,
        -48,  16,
        -48, -16,
        -16, -16
    )

    piece:moveTo(112, 400)
    collider:addShape(piece)
end

function love.update(dt)
    player1:update(dt)
    collider:update(dt)
end

function love.draw()
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.setBlendMode("alpha")
    player1:draw()
    love.graphics.setColor(255, 255, 255, 255)
    floor:draw()
    love.graphics.setColor(255, 255, 255, 255)
    piece:draw()
end

function love.keypressed(key)
    if key == player1.keys.jump then
        player1:jump()
    end
end
