shapes = require "collider.shapes"

require "class"
require "object"

class "Player" (Object) {
    max_vx = 128,
    max_vy = 128,
}

function Player:__init__(colour, keys, ...)
    Object.__init__(self, ...)

    self.shape = shapes.newCircleShape(self.x, self.y, 16)
    self.shape.info = {type = "player", object = self}

    self.grounded = false

    self.colour = colour
    self.keys = keys
end

function Player:update(dt)
    Object.update(self, dt)

    self.vy = math.min(self.vy + 100 * dt, 128)

    if love.keyboard.isDown(self.keys.left) then
        self.vx = -128
    elseif love.keyboard.isDown(self.keys.right) then
        self.vx = 128
    else
        self.vx = 0
    end

    self.x = self.x % 1024

    self.shape:moveTo(self.x, self.y)
    self.grounded = false
end

function Player:draw(width)
    love.graphics.setBlendMode("alpha")
    love.graphics.setColor(self.colour)
    love.graphics.circle("fill", self.x, self.y, 16, 32)
end

function Player:push(dx, dy)
    self.x, self.y = self.x + dx, self.y + dy
    
    if (dy < 0) then self.grounded = true end

    if math.abs(dx) < 0.001 then dy = 0 end
    if math.abs(dy) < 0.001 then dy = 0 end

    if (dy * self.vy) < 0 then self.vy = self.vy * 0.99 end

    self.x = self.x % 1024
    self.shape:moveTo(self.x, self.y)
end

function Player:jump()
    if self.grounded then self.vy = -128 end
end
